
/*
 * filter.c
 *
 * functions (or in-line code) for all cascading filters
 *
 */

/*
 * Copyright (c) 2001 Portland State University 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by Portland State University.
 * 4. The name of Portland State University may not be used to endorse 
 *    or promote products derived from this software without specific 
 *    prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR/S ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR/S BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifdef	HAVE_CONFIG_H
#include <config.h>
#endif

#include <sys/types.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/udp.h>
#include <netinet/tcp.h>
#include <stdlib.h>
#include <signal.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <pcap.h>
#include <syslog.h>
#ifdef	TIME_WITH_SYS_TIME
#include <time.h>
#endif

#include "ircfr.h"

ip_filter(unsigned int caplength, struct t_entry *te) 
{
	int ircresult = 0;
	extern FILE *global_fd;

       	ircresult = ircscan(te, global_fd);

	return(ircresult);
}

/* note: we do not count "non-ip" except in the case
 * of fixed_ipproto, specified ip_prpto, and fixed_cast.
 * The other filters are only for ip addresses in terms
 * of their "xtra" bytes.
 */
void
non_ip_filter(caplength) 
{
	extern int nol2flag;
	return;
}

dump_te(struct t_entry *te)
{
	printf("te %x\n",te);
	if (te == NULL)
		return;

	printf("flags e:%d m:%d b:%d s:%d f:%d a:%d r:%d\n", 
		te->eflag, 
		te->mflag, 
		te->bflag, 
		te->synflag, 
		te->finflag, 
		te->ackflag, 
		te->resetflag);
	printf("ip src %x\n", te->src.s_addr);
	printf("ip dst %x\n", te->dst.s_addr);
	printf("L4 src %d\n", te->sport);
	printf("L4 dst %d\n", te->dport);
	printf("L4 proto %d\n", te->proto);
	printf("ip bytes %d\n", te->bytes);
	printf("ip psize %d\n", te->psize);
	/*
	unsigned char *p;
	*/
}
