#! /usr/bin/perl

#
# stirc.pl - extract IPs from snort bleeding-botcc.rules
#	and put them in ourmon db file suitable for use by
#	ourmon's backend.
#
# syntax:
#
#	stirc  inputfile  outputfile
#
#	inputfile - bleeding-botcc.rules
#	outputfile - db format file for irc.pl
#

use Socket;
use Getopt::Std;
use File::Basename();
#use Time::Local;
# comment in for ctime, note that it overrides localtime
#use Time::localtime;

$debug = 0;
$argc=$#ARGV+1;

if ($argc != 2) {
	print "syntax: # stirc.pl inputfile outputfile\n";
	exit(1);
}

my $input = $ARGV[0];
my $output = $ARGV[1];

#%options=();
#getopts("e:4:z:ditNP:p:D:E:w:h:H:",\%options);
# like the shell getopt, "d:" means d takes an argument
#print "Unprocessed by Getopt::Std:\n" if $ARGV[0];
#foreach (@ARGV) {
#  print "$_\n";
#}
#if (defined $options{d}) {
#	$debug = 1;
#}

doit($input, $output);

exit(0);

#
# doit
# parse input file
# throw out extraneous bits and extract the good parts
#
sub doit() { 
	
	my $inputfile = $_[0];
	my $outputfile = $_[1];
	my $curline;
	my @words;
	my $ipaddr;
	my $port;

	#my $basename = File::Basename::basename($inputfile);
	#my @PARTS = split(" ", $basename);

	open(FILE, $inputfile) || die "can't open $inputfile: $!\n";

	my $linecount = 0;
	while(<FILE>) {

		$linecount++;
		s/\n//g;
	 	s/\[//g;
	 	s/\]//g;
		my $curline = $_;
		# note the escape needed
		@words = split(/ /, $curline);
#if( $words[0] =~ /^#.*/){
#	print "true\n";
#}
#else {
#	print "false\n";
#}
		if( $words[0] =~ /^#.*/){
			next;
		}
                elsif( $words[0] =~ /<\/p.*/){
			next;
		}
                elsif( $words[0] =~ /alert/){
#print "$words[5]\n";
			$iplist = $words[5];
			@ips = split(/,/, $iplist);
			foreach $ipaddr (@ips) {
	#			print "$ipaddr any\n";
				iptodb($ipaddr, $outputfile);
	#			dbmtest($ipaddr, $outputfile);
			}
		}

	}  # end loop
	close(FILE);
}

sub
isnumber
{
	my $number = $_[0];
	return( ($number =~ /^\d+$/)?1:0 );
}

# Ups - unique port sig
#
# print out port sigs that are unique
# on this sample pass.  We essentially
# boil the single ip instances down into classes
# as a result.  E.g., maybe you are seeing 10 different
# sasser worms or related things from 10 diff. ip srcs.
#
sub
iptodb
{
	my $ipaddr = $_[0];
	my $dbmfile = $_[1];
	my $key;
	my $value;

	dbmopen(%map, $dbmfile, 0666);
	# at this point key and value are the same, we need only
	# check for existance

	$key = $value = $ipaddr;
	# store in database
	$map{$key} = $value;	
	dbmclose(%map);
}

sub
dbmtest
{
	my $ipaddr = $_[0];
	my $dbmfile = $_[1];

	# for testing open the database and see if we get the key
	dbmopen(%map, $dbmfile, 0666);
	if ($map{$ipaddr}) {
		print "found it: $ipaddr\n";
	}
	if ($map{"1.1.1.1"}) {
		print "1.1.1.1: did not find it\n";
	}
	dbmclose(%map);
}
