#! /usr/bin/perl

#
# snorttoour.pl - extract IPs from snort bleeding-botcc.rules
#	and put them in ourmon IP blacklist file format
#
# syntax:
#
#	snorttoour  inputfile  > stdout
#
#	inputfile - bleeding-botcc.rules
#	stdout - list of IP addresses plus ports only
#

use Socket;
use Getopt::Std;
use File::Basename();
#use Time::Local;
# comment in for ctime, note that it overrides localtime
#use Time::localtime;

$debug = 0;
$argc=$#ARGV+1;

if ($argc != 1) {
	print "syntax: # ccip.pl imputfile\n";
	print "example: # ccip.pl /home/mrourmon/etc/foo.txt\n";
	exit(1);
}

my $input = $ARGV[0];

#%options=();
#getopts("e:4:z:ditNP:p:D:E:w:h:H:",\%options);
# like the shell getopt, "d:" means d takes an argument
#print "Unprocessed by Getopt::Std:\n" if $ARGV[0];
#foreach (@ARGV) {
#  print "$_\n";
#}
#if (defined $options{d}) {
#	$debug = 1;
#}

doit($input);

exit(0);

#
# doit
# parse input file
# throw out extraneous bits and extract the good parts
#
sub doit() { 
	
	my $inputfile = $_[0];
	my $curline;
	my @words;
	my $ipaddr;
	my $port;

	#my $basename = File::Basename::basename($inputfile);
	#my @PARTS = split(" ", $basename);

	open(FILE, $inputfile) || die "can't open $inputfile: $!\n";

	my $linecount = 0;
	while(<FILE>) {

		$linecount++;
		s/\n//g;
	 	s/\[//g;
	 	s/\]//g;
		my $curline = $_;
		# note the escape needed
		@words = split(/ /, $curline);
#if( $words[0] =~ /^#.*/){
#	print "true\n";
#}
#else {
#	print "false\n";
#}
		if( $words[0] =~ /^#.*/){
			next;
		}
                elsif( $words[0] =~ /<\/p.*/){
			next;
		}
                elsif( $words[0] =~ /alert/){
#print "$words[5]\n";
			$iplist = $words[5];
			@ips = split(/,/, $iplist);
			foreach $ipaddr (@ips) {
				print "$ipaddr any\n";
			}
		}

	}  # end loop
	close(FILE);
}

sub
isnumber
{
	my $number = $_[0];
	return( ($number =~ /^\d+$/)?1:0 );
}

