#!/bin/sh
# run this script once a day at 23.59 or so.  
# before daily run and batchip run on hour

WEBDIR=/usr/local/www/data/ourmon

# roll files back one slot 
# 6 to 7, 5 to 6 etc.

cd $WEBDIR

for i in 7 6 5 4 3 2 1 
do
	# A is one less than i
	A=`expr $i - 1`
	if [ -f topn.$A.txt ]; then 
		cp topn.$A.txt topn.$i.txt
	fi

	if [ -f topn_ipdst.$A.txt ]; then 
		cp topn_ipdst.$A.txt topn_ipdst.$i.txt
	fi

	if [ -f topn_ipsrc.$A.txt ]; then 
		cp topn_ipsrc.$A.txt topn_ipsrc.$i.txt
	fi

	if [ -f topicmp.$A.txt ]; then 
		cp topicmp.$A.txt topicmp.$i.txt
	fi

	if [ -f topicmp_ipdst.$A.txt ]; then 
		cp topicmp_ipdst.$A.txt topicmp_ipdst.$i.txt
	fi

	if [ -f topicmp_ipsrc.$A.txt ]; then 
		cp topicmp_ipsrc.$A.txt topicmp_ipsrc.$i.txt
	fi

	if [ -f topudp.$A.txt ]; then 
		cp topudp.$A.txt topudp.$i.txt
	fi

	if [ -f topudp_ipdst.$A.txt ]; then 
		cp topudp_ipdst.$A.txt topudp_ipdst.$i.txt
	fi

	if [ -f topudp_ipsrc.$A.txt ]; then 
		cp topudp_ipsrc.$A.txt topudp_ipsrc.$i.txt
	fi

	if [ -f topnippkts.$A.txt ]; then 
		cp topnippkts.$A.txt topnippkts.$i.txt
	fi

	if [ -f topsyn.$A.txt ]; then 
		cp topsyn.$A.txt topsyn.$i.txt
	fi

	if [ -f allworm.$A.txt ]; then 
		cp allworm.$A.txt allworm.$i.txt
	fi

	if [ -f event.$A.txt ]; then 
		cp event.$A.txt event.$i.txt
	fi

	if [ -f newportsig.$A.txt ]; then 
		cp newportsig.$A.txt newportsig.$i.txt
	fi

	if [ -f ircreport.$A.txt ]; then 
		cp ircreport.$A.txt ircreport.$i.txt
	fi

	if [ -f wormsum.all.$A.txt ]; then 
		cp wormsum.all.$A.txt wormsum.all.$i.txt
	fi

	if [ -f wormsum.445.$A.txt ]; then 
		cp wormsum.445.$A.txt wormsum.445.$i.txt
	fi

	if [ -f wormsum.40w.$A.txt ]; then 
		cp wormsum.40w.$A.txt wormsum.40w.$i.txt
	fi

	if [ -f p2psum.$A.txt ]; then 
		cp p2psum.$A.txt p2psum.$i.txt
	fi

	if [ -f syndump.$A.txt ]; then 
		cp syndump.$A.txt syndump.$i.txt
	fi

	if [ -f emaildump.$A.txt ]; then 
		cp emaildump.$A.txt emaildump.$i.txt
	fi

	if [ -f potdump.$A.txt ]; then 
		cp potdump.$A.txt potdump.$i.txt
	fi

done

# deal with current day rolled over to previous day
if [ -f topn_today.txt ]; then 
	cp topn_today.txt topn.0.txt
fi
if [ -f topnippkts_today.txt ]; then 
	cp topnippkts_today.txt topnippkts.0.txt
fi
if [ -f topn_ipdst_today.txt ]; then 
	cp topn_ipdst_today.txt topn_ipdst.0.txt
fi
if [ -f topn_ipsrc_today.txt ]; then 
	cp topn_ipsrc_today.txt topn_ipsrc.0.txt
fi


if [ -f topicmp_today.txt ]; then 
	cp topicmp_today.txt topicmp.0.txt
fi

if [ -f topicmp_ipdst_today.txt ]; then 
	cp topicmp_ipdst_today.txt topicmp_ipdst.0.txt
fi

if [ -f topicmp_ipsrc_today.txt ]; then 
	cp topicmp_ipsrc_today.txt topicmp_ipsrc.0.txt
fi


if [ -f topudp_today.txt ]; then 
	cp topudp_today.txt topudp.0.txt
fi
if [ -f topudp_ipdst_today.txt ]; then 
	cp topudp_ipdst_today.txt topudp_ipdst.0.txt
fi
if [ -f topudp_ipsrc_today.txt ]; then 
	cp topudp_ipsrc_today.txt topudp_ipsrc.0.txt
fi

if [ -f topsyn_today.txt ]; then 
	cp topsyn_today.txt topsyn.0.txt
fi
echo "topsyn_today file restarted" > topsyn_today.txt

if [ -f allworm_today.txt ]; then 
	cp allworm_today.txt allworm.0.txt
fi
echo "allworm file restarted" > allworm_today.txt

if [ -f event_today.txt ]; then 
	mv event_today.txt event.0.txt
fi
echo "event file restarted" > event_today.txt

if [ -f newportsig_today.txt ]; then 
	mv newportsig_today.txt newportsig.0.txt
fi
echo "portsig file restarted" > newportsig_today.txt

if [ -f ircreport_today.txt ]; then 
	cp ircreport_today.txt ircreport.0.txt
fi
echo "ircreport file restarted" > ircreport_today.txt

if [ -f wormsum.all_daily.txt ]; then 
	cp wormsum.all_daily.txt wormsum.all.0.txt
fi
echo "worm/syntuple all report file restarted" > wormsum.all_daily.txt

if [ -f wormsum.445_daily.txt ]; then 
	cp wormsum.445_daily.txt wormsum.445.0.txt
fi
echo "port 445 syntuple sum report file restarted" > wormsum.445_daily.txt

if [ -f wormsum.40w_daily.txt ]; then 
	cp wormsum.40w_daily.txt wormsum.40w.0.txt
fi
echo "local net weight >= 40 worm sum report file restarted" > wormsum.40w_daily.txt

if [ -f p2psum.daily.txt ]; then 
	cp p2psum.daily.txt p2psum.0.txt
fi
echo "local net p2p syntuple sum report file restarted" > p2psum.daily.txt

if [ -f syndump.daily.txt ]; then 
	cp syndump.daily.txt syndump.0.txt
fi
echo "syndump syntuple sum report file restarted" > syndump.daily.txt

if [ -f emaildump.daily.txt ]; then 
	cp emaildump.daily.txt emaildump.0.txt
fi
echo "emaildump syntuple sum report file restarted" > emaildump.daily.txt

if [ -f potdump.daily.txt ]; then 
	cp potdump.daily.txt potdump.0.txt
fi
echo "potdump syntuple sum report file restarted" > potdump.daily.txt
